/**
 * @file main.c
 * @author WHXY
 * @brief 
 * @version 0.1
 * @date 2021-04-22
 *
 * @copyright Copyright (c) 2021
 *
 *代码许可和免责信息
 *武汉芯源半导体有限公司授予您使用所有编程代码示例的非专属的版权许可，您可以由此
 *生成根据您的特定需要而定制的相似功能。根据不能被排除的任何法定保证，武汉芯源半
 *导体有限公司及其程序开发商和供应商对程序或技术支持（如果有）不提供任何明示或暗
 *含的保证或条件，包括但不限于暗含的有关适销性、适用于某种特定用途和非侵权的保证
 *或条件。
 *无论何种情形，武汉芯源半导体有限公司及其程序开发商或供应商均不对下列各项负责，
 *即使被告知其发生的可能性时，也是如此：数据的丢失或损坏；直接的、特别的、附带的
 *或间接的损害，或任何后果性经济损害；或利润、业务、收入、商誉或预期可节省金额的
 *损失。
 *某些司法辖区不允许对直接的、附带的或后果性的损害有任何的排除或限制，因此某些或
 *全部上述排除或限制可能并不适用于您。
 *******************************************************************************/

/******************************************************************************
 * Include files
 ******************************************************************************/
#include "../inc/main.h"

/******************************************************************************
* Local pre-processor symbols/macros ('#define')
******************************************************************************/

/******************************************************************************
* Global variable definitions (declared in header file with 'extern')
******************************************************************************/

/******************************************************************************
 * Local type definitions ('typedef')
 ******************************************************************************/

/******************************************************************************
 * Local function prototypes ('static')
 ******************************************************************************/
void RCC_Configuration(void);
void GPIO_Configuration(void);
void NVIC_Configuration(void);
void LED_Configuration(void);
static void WWDT_Config(void);

/******************************************************************************
 * Local variable definitions ('static')                                      *
 ******************************************************************************/
LED_InitTypeDef LED1 = { 0 }, LED2 = { 0 };
/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/

/*****************************************************************************
* Function implementation - global ('extern') and local ('static')
******************************************************************************/

/**
* @brief
* @return int32_t
*/
int32_t main(void)
{
    /* System Clocks Configuration */
    RCC_Configuration();
    /* GPIO Configuration */
    GPIO_Configuration();
    /* LED Configuration */
    LED_Configuration();
    /* 节拍定时器初始化 */
    SysTick_Config(SystemCoreClock / 1000 * 200);   // 200ms 产生一次中断
    /* 配置WWDT */
    WWDT_Config();
    /* NVIC Configuration */
    NVIC_Configuration();

    if (RCC_GetRstFlag(RCC_FLAG_WWDTRST))
    {
        LED2.LED_On(&LED2);
    }

    while (1)
    {

    }
}

/**
  * @brief  Configures the different system clocks.
  * @param  None
  * @retval None
  */
void RCC_Configuration(void)
{
    /* 0. HSI使能并校准 */
    __RCC_FLASH_CLK_ENABLE();
    FLASH_SetLatency(FLASH_Latency_2);
    RCC_HSI_Enable(RCC_HSIOSC_DIV1);

    /* 1. 设置HCLK和PCLK的分频系数　*/
    RCC_HCLKPRS_Config(RCC_HCLK_DIV1);
    RCC_PCLKPRS_Config(RCC_PCLK_DIV1);  
    RCC_SystemCoreClockUpdate(48000000);
}

/**
  * @brief  Configure the GPIO Pins.
  * @param  None
  * @retval None
  */
void GPIO_Configuration(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};

    __RCC_GPIOA_CLK_ENABLE();

    /* 配置PA4为按键输入 */
    GPIO_InitStruct.IT = GPIO_IT_FALLING;
    GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
    GPIO_InitStruct.Pins = GPIO_PIN_4;
    GPIO_Init(CW_GPIOA, &GPIO_InitStruct);
}

/**
  * @brief  Configure the nested vectored interrupt controller.
  * @param  None
  * @retval None
  */
void NVIC_Configuration(void)
{
    __disable_irq();
    NVIC_SetPriority(SysTick_IRQn, 1);
    NVIC_SetPriority(GPIOA_IRQn, 0);
    NVIC_SetPriority(WDT_IRQn, 0);
    NVIC_EnableIRQ(WDT_IRQn);
    NVIC_EnableIRQ(GPIOA_IRQn);
    __enable_irq();
}

void LED_Configuration(void)
{
    /* LED 初始化 */
    LED1.LED_Port = CW_GPIOA;
    LED1.LED_Pin = GPIO_PIN_15;
    LED_Init(&LED1);
    LED1.LED_On(&LED1);

    LED2.LED_Port = CW_GPIOC;
    LED2.LED_Pin = GPIO_PIN_10;
    LED_Init(&LED2);
    LED2.LED_Off(&LED2);
}


static void WWDT_Config(void)
{
    WWDT_InitTypeDef WWDT_InitStruct = { 0 };

    __RCC_WWDT_CLK_ENABLE();

    WWDT_InitStruct.WWDT_CounterValue = 0x60;
    WWDT_InitStruct.WWDT_ITState = ENABLE;
    WWDT_InitStruct.WWDT_Prescaler = WWDT_Prescaler_DIV524288;    // 
    WWDT_InitStruct.WWDT_WindowValue = 0x50;    //
    WWDT_Init(&WWDT_InitStruct);

    WWDT_Cmd();
}

void SysTick_Handler(void)
{
    WWDT_FEED(0x60);
    LED1.LED_Toggle(&LED1);
}

void WDT_IRQHandler(void)
{
    /* USER CODE BEGIN */
    static uint8_t flag = 0;
    WWDT_ClearFlag();
    if (flag < 2)
    {
        WWDT_FEED(0x60);
        LED1.LED_On(&LED1);    // 首次中断后，喂2次狗，LED1常亮，指示要复位
        flag++;
    }
    /* USER CODE END */
}
/******************************************************************************
 * EOF (not truncated)
 ******************************************************************************/
#ifdef  USE_FULL_ASSERT
/**
* @brief  Reports the name of the source file and the source line number
*         where the assert_param error has occurred.
* @param  file: pointer to the source file name
* @param  line: assert_param error line source number
* @retval None
*/
void
assert_failed(uint8_t* file, uint32_t line)
{
    /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number,
       tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
    /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

